
###############################################################################
#
#    RABBIT Vulnerability Scanner. Black-Box interactive vulnerability scanner.
#    Copyright (C) 2010  Santiago Alessandri, Carlos Gaston Traberg
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

class BasePlugin(object):
    
    core = rabbit_core
    dependencies = []
    options = tuple()
    description = ''
    
    def get_option(self, name):
        return self.__class__.get_class_option(name)
    
    def get_core(self):
        return self.__class__.get_class_core()
    
    def get_options(self):
        return self.__class__.get_class_options()
    
    def clean(self):
        pass
    
    @classmethod
    def create_option(cls, category, variable, value, value_class):
        return cls.core.get_config_manager().create_option(category, variable, value, value_class)
    
    @classmethod
    def get_class_option(cls, name):
        return [x for x in cls.get_class_options() if x.get_variable() == name][0]
    
    @classmethod
    def get_class_options(cls):
        return cls.options
    
    @classmethod
    def get_class_core(cls):
        return cls.core
    
    @classmethod
    def get_class_dependencies(cls):
        return cls.dependencies
    
    @classmethod
    def get_class_type(cls):
        return cls.type
    
    @classmethod
    def get_class_description(cls):
        return cls.description
