
###############################################################################
#
#    RABBIT Vulnerability Scanner. Black-Box interactive vulnerability scanner.
#    Copyright (C) 2010  Santiago Alessandri, Carlos Gaston Traberg
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

from Vulnerability import Vulnerability

class AuditManager(object):
    
    def __init__(self, core):
        self._core = core
        self._plugins = None
    
    def start(self):
        for request in self._core.get_to_audit():
            for plugin in self._plugins:
                plugin.audit(request)
    
    def set_audit_plugins(self, plugins):
        self._plugins = plugins
    
    def clean(self):
        for plugin in self._plugins:
            plugin.clean()
        Vulnerability.id = 0
        self._plugins = None