
###############################################################################
#
#    RABBIT Vulnerability Scanner. Black-Box interactive vulnerability scanner.
#    Copyright (C) 2010  Santiago Alessandri, Carlos Gaston Traberg
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

class Vulnerability(object):
    
    id = 0
    
    def __init__(self, request, type, severity, parameter = ''):
        self._id = Vulnerability.id
        Vulnerability.id += 1
        self._request = request
        self._type = type
        self._severity = severity
        self._parameter = parameter
    
    def get_id(self):
        return self._id
    
    def get_request(self):
        return self._request
    
    def get_type(self):
        return self._type
    
    def get_severity(self):
        return self._severity
    
    def get_parameter(self):
        return self._parameter
    
    def __str__(self):
        return "%s Vulnerability(%d): %s found at %s in parameter: %s = %s" % (self.get_severity(),
                                                                          self.get_id(),
                                                                          self.get_type(),
                                                                          self.get_request().get_url(),
                                                                          self.get_parameter(),
                                                                          self.get_request().get_parameters()[self.get_parameter()])
