
###############################################################################
#
#    RABBIT Vulnerability Scanner. Black-Box interactive vulnerability scanner.
#    Copyright (C) 2010  Santiago Alessandri, Carlos Gaston Traberg
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

class RequestManager(object):
    
    def __init__(self, core):
        self._core = core
        self._filter_plugins = None
    
    def set_filter_plugins(self, plugins):
        self._filter_plugins = plugins
        self._filter_plugins.sort(key=lambda x: x.get_weight())
    
    def send(self, request):
        return self._filter_plugins[0].request(request)
    
    def next(self, request, plugin):
        index = self._filter_plugins.index(plugin)
        return self._filter_plugins[index+1].request(request)
    
    def clean(self):
        for plugin in self._filter_plugins:
            plugin.clean()
        self._filter_plugins = None
    
    
    
    