#!/usr/bin/python

from xml.dom import minidom
import os
import sys

sys.path.append(os.path.dirname(os.path.dirname(os.path.realpath(__file__))))

import core.RabbitCore
from utils.ClassFactory import class_from_name

if len(sys.argv) == 2:
    file_name = sys.argv[1]
else:
    file_name = os.path.dirname(os.path.realpath(__file__)) + "/xml-fe.xml"

module_path = {'finger_plugins':'plugins.discovery.finger',
               'discovery_filter_plugins':'plugins.discovery.filter',
               'request_filter_plugins':'plugins.request.filter',
               'output_plugins':'plugins.output',
               'information_finder_plugins':'plugins.discovery.information_finder',
               'audit_plugins':'plugins.audit',
               'request_generator_plugins':'plugins.discovery.request_generator'}

dom_tree = minidom.parse(file_name).firstChild

for category in dom_tree.childNodes:
    
    if category.nodeName == '#text':
        continue
    
    plugins = []
    
    for plugin in category.childNodes:
        if plugin.nodeName == '#text':
            continue
        
        plugin_path = module_path[str(category.nodeName)] + '.' + plugin.getAttribute('name')
        
        plugin_class = class_from_name(plugin_path)
        for option in plugin.childNodes:
            if option.nodeName == '#text':
                continue
            
            value = option.getAttribute('value')
            type = option.getAttribute('class')
            if type == 'int':
                value = int(value)
            elif type == 'str':
                value = str(value)
            
            plugin_class.get_class_option(option.getAttribute('name')).set_value(value)
        
        plugins.append(plugin.getAttribute('name'))

    rabbit_core.get_option(category.nodeName).set_value(plugins)
    
rabbit_core.start()
