
###############################################################################
#
#    RABBIT Vulnerability Scanner. Black-Box interactive vulnerability scanner.
#    Copyright (C) 2010  Santiago Alessandri, Carlos Gaston Traberg
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

import re

from core.discovery_subsystem.DiscoveryFilterPlugin import DiscoveryFilterPlugin
from core.constants.option_types import STRING

class URLRestricterPlugin(DiscoveryFilterPlugin):
    
    weight = 0
    
    options = (
        DiscoveryFilterPlugin.create_option('discovery.filter.URLRestricterPlugin',
                                            'regex', '.*', STRING),
    )
    
    def __init__(self):
        DiscoveryFilterPlugin.__init__(self)
        self._regex = re.compile(self.get_option('regex').get_value())
    
    def filter(self, request):
        if self._regex.match(request.get_url()) == None:
            return None
        return self._next(request)