
###############################################################################
#
#    RABBIT Vulnerability Scanner. Black-Box interactive vulnerability scanner.
#    Copyright (C) 2010  Santiago Alessandri, Carlos Gaston Traberg
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

from core.request_subsystem.Request import Request
from core.discovery_subsystem.DiscoveryFingerPlugin import DiscoveryFingerPlugin
from core.constants.option_types import STRING

class BasicFingerPlugin(DiscoveryFingerPlugin):
    
    options = (
        DiscoveryFingerPlugin.create_option("discovery.finger.BasicFingerPlugin", "target", "", STRING),
    )
    
    def __init__(self):
        DiscoveryFingerPlugin.__init__(self)
    
    def start(self):
        req = Request("GET", self.get_option("target").get_value())
        return [req]